Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        lvwAssigned.AllowDrop = True
        lvwAssigned.MultiSelect = True

        lvwUnassigned.AllowDrop = True
        lvwUnassigned.MultiSelect = True
    End Sub

    Private Sub ListView_ItemDrag(ByVal sender As Object, ByVal e As System.Windows.Forms.ItemDragEventArgs) Handles lvwAssigned.ItemDrag, lvwUnassigned.ItemDrag
        Dim lvw As ListView = DirectCast(sender, ListView)
        Dim dragged_items As New List(Of ListViewItem)
        For Each selected_item As ListViewItem In lvw.SelectedItems
            dragged_items.Add(selected_item)
        Next selected_item

        Dim result As DragDropEffects = _
            lvw.DoDragDrop(New DataObject("System.Collections.Generic.List(Of System.Windows.Forms.ListViewItem)", dragged_items), DragDropEffects.Move)

        ' Remove the dragged items if necessary.
        If result = DragDropEffects.Move Then
            For Each selected_item As ListViewItem In dragged_items
                lvw.Items.Remove(selected_item)
            Next selected_item
        End If
    End Sub

    Private Sub ListView_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lvwAssigned.DragEnter, lvwUnassigned.DragEnter
        ' Check for the custom DataFormat ListViewItem array.
        If e.Data.GetDataPresent("System.Collections.Generic.List(Of System.Windows.Forms.ListViewItem)") Then
            e.Effect = DragDropEffects.Move
        Else
            e.Effect = DragDropEffects.None
        End If
    End Sub

    Private Sub ListView_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lvwAssigned.DragDrop, lvwUnassigned.DragDrop
        Dim lvw As ListView = DirectCast(sender, ListView)
        Dim dragged_items As List(Of ListViewItem) = _
            e.Data.GetData("System.Collections.Generic.List(Of System.Windows.Forms.ListViewItem)")

        Dim pt As Point = lvw.PointToClient(New Point(e.X, e.Y))
        Dim lvi As ListViewItem = lvw.GetItemAt(pt.X, pt.Y)
        Dim index As Integer
        If lvi IsNot Nothing Then
            index = lvi.Index
        End If

        For Each list_view_item As ListViewItem In dragged_items
            ' Add the item to the target list.
            Dim new_item As ListViewItem = DirectCast(list_view_item.Clone(), ListViewItem)

            If lvi Is Nothing Then
                lvw.Items.Add(new_item)
            Else
                lvw.Items.Insert(index, new_item)
                index += 1
            End If
        Next list_view_item
    End Sub
End Class
